--- chan_oss.c.org	Tue Aug 10 15:22:18 2004
+++ chan_oss.c	Tue Aug 10 15:46:36 2004
@@ -329,7 +329,11 @@
 		return -1;
 	}
 	res = ioctl(fd, SNDCTL_DSP_SETDUPLEX, 0);
-	if (res >= 0) {
+	
+	/* Check to see if duplex set (FreeBSD Bug)*/
+	res = ioctl(fd, SNDCTL_DSP_GETCAPS, &fmt);
+	
+	if ((fmt & DSP_CAP_DUPLEX) && !res) {
 		if (option_verbose > 1) 
 			ast_verbose(VERBOSE_PREFIX_2 "Console is full duplex\n");
 		full_duplex = -1;
